//-----
// Dedicated Minigames
//-----
// Allows you to make dedicated minigames. Dedicated minigames will stay when the
// owner leaves them and will not be destroyed when there are no users in them.
//-----
// By Zack "Zack0Wack0" Corr
// zack0wack0.com
//-----
// Server Functions & Config
//-----
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Admin only","Dedicated Minigame","$DedicatedMinigame::AdminOnly","bool","Script_DedicatedMinigame",1,0,0);
}
else
{
	//Do you have to be an admin to dedicate minigames? (Enabled by default)
	$DedicatedMinigame::AdminOnly = 1;
}
//-----
function serverCmdDedicateMinigame(%client)
{
	%mini = getMinigameFromObject(%client);
	if(!isObject(%mini))
	{
		messageClient(%client,'','You are not in a mini-game!');
		return;
	}
	if(isObject(%mini) && %mini.owner != %client)
	{
		messageClient(%client,'','Only the minigame owner may dedicate mini-games.');
		return;
	}
	switch($DedicatedMinigame::AdminOnly)
	{
		case 1:
			if(%client.isAdmin)
			{
				%mini.dedicateMinigame(%client);
			}
			else
			{
				messageClient(%client,'','Sorry, only admins may dedicate mini-games on this server.');
				return;
			}
		case 0:
			%mini.dedicateMinigame(%client);
	}
}
function MinigameSO::dedicateMinigame(%mini,%client)
{
	switch(%mini.isDedi)
	{
		case 0:
			%mini.chatMsgAll(%client.name@"\c6 has dedicated the mini-game.",%client);
			%mini.isDedi = 1;
		case 1:
			%mini.chatMsgAll(%client.name@"\c6 has un-dedicated the mini-game.",%client);
			%mini.isDedi = 0;
	}
}
//-----
// Main Package
//-----
package DedicatedMinigame
{
	function CreateMinigameSO(%client,%title,%a,%b,%c,%d)
	{
		%mini = Parent::CreateMinigameSO(%client,%title,%a,%b,%c,%d);
		if(isObject(%mini))
		{
			%mini.ownerBL_ID = %client.BL_ID;
		}
		return %mini;
	}
	function MinigameSO::addMember(%mini,%client)
	{
		if(%mini.ownerBL_ID == %client.BL_ID && %mini.isDedi && isObject(%mini.fakeowner))
		{
			%mini.fakeowner.delete();
			%mini.owner = %client;
			%client.minigame = %mini;
			commandtoclient(%client,'SetPlayingMinigame',1);
			commandtoclient(%client,'SetRunningMinigame',1);
			%mini.member[%mini.numMembers] = %client;
			%mini.numMembers++;
			%client.setScore(0);
			%client.instantrespawn();
			%mini.chatmsgall("\c1"@%client.name@" has joined the mini-game. (Mini-game owner)",%client);
			return;
		}
		Parent::addMember(%mini,%client);
	}
	function MinigameSO::removeMember(%mini,%client)
	{
		if(%mini.ownerBL_ID == %client.BL_ID && %mini.isDedi)
		{
			%mini.fakeowner = new AiConnection();
			%mini.fakeowner.fakename = %client.name;
			%mini.fakeowner.name = %client.name;
			%mini.fakeowner.brickgroup = %client.brickgroup;
			%mini.owner = %mini.fakeowner;
			for(%m=0;%m<%mini.numMembers;%m++)
			{
				if(%mini.member[%m] == %client)
				{
					%mini.member[%m] = "";
					break;
				}
			}
			for(%i=%m+1;%i<%mini.numMembers;%i++)
			{
				%mini.member[%i-1] = %mini.member[%i];
			}
			%mini.numMembers--;
			%client.minigame = "";
			commandtoclient(%client,'SetPlayingMinigame',0);
			commandtoclient(%client,'SetRunningMinigame',0);
			%client.setScore(0);
			%client.instantrespawn();
			%mini.chatmsgall("\c1"@%client.name@" has left the mini-game. (Mini-game owner)",%client);
			return;
		}
		else
		{
			Parent::removeMember(%mini,%client);
		}
	}
	function AiConnection::spawnPlayer(%ai)
	{
		if(%ai.fakename $= "")
		{
			return Parent::spawnPlayer(%ai);
		}
	}
	function AiConnection::InstantRespawn(%ai)
	{
		if(%ai.fakename $= "")
		{
			return Parent::InstantRespawn(%ai);
		}
	}
};
activatePackage(DedicatedMinigame);